--------------------------------------------------------------------------------
-- Weapon Nokia TV + Projectile Nokia TV + Object Nokia TV
-- Kind of modified anvil, made by DC
-- Script by Nemesis, September 2012
--------------------------------------------------------------------------------

-- Setup tables
if cc==nil then cc={} end
cc.nokia={}
cc.nokia.tv={}
cc.nokia.tvo={}

-- Load & Prepare Ressources
cc.nokia.gfx_wpn=loadgfx("weapons/NokiaTV-control.png")
setmidhandle(cc.nokia.gfx_wpn)
cc.nokia.gfx_pro=loadgfx("weapons/NokiaTV.png")
setmidhandle(cc.nokia.gfx_pro)
cc.nokia.gfx_pro1=loadgfx("weapons/NokiaTV-01.png")
setmidhandle(cc.nokia.gfx_pro1)
cc.nokia.gfx_pro2=loadgfx("weapons/NokiaTV-02.png")
setmidhandle(cc.nokia.gfx_pro2)
cc.nokia.gfx_pro3=loadgfx("weapons/NokiaTV.png")
setmidhandle(cc.nokia.gfx_pro3)
cc.nokia.sfx_fly=loadsfx("airstrike.ogg")	
cc.nokia.sfx_bounce=loadsfx("stoneimpact.ogg")
cc.nokia.sfx_noise=loadsfx("noise.ogg")

--------------------------------------------------------------------------------
-- Weapon: Nokia TV
--------------------------------------------------------------------------------

cc.nokia.id=addweapon("cc.nokia","Nokia TV",cc.nokia.gfx_pro,0,3,"airborne")

function cc.nokia.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(cc.nokia.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function cc.nokia.attack(attack)
	if (weapon_shots<=0) and (weapon_position==1) then
	playsound(cc.nokia.sfx_fly)
		-- No more weapon switching!
		useweapon(0)
		--playsound(cc.nokia.sfx_attack)
		weapon_shots=weapon_shots+1
		-- Attack
		pid=createprojectile(cc.nokia.tv.id)
		projectiles[pid]={}
		projectiles[pid].x=weapon_x
		projectiles[pid].y=-500
		projectiles[pid].sx=0
		projectiles[pid].sy=10.0
		-- End Turn
		endturn()
	end
end

--------------------------------------------------------------------------------
-- Projectile: Nokia TV
--------------------------------------------------------------------------------

cc.nokia.tv.id=addprojectile("cc.nokia.tv")	-- Add Projectile

function cc.nokia.tv.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	-- Draw projectile
	drawimage(cc.nokia.gfx_pro,projectiles[id].x,projectiles[id].y)
end

function cc.nokia.tv.update(id)							-- Update
	-- Particle Tail
	particle(p_explosion,projectiles[id].x-20,projectiles[id].y+15)
	particlecolor(255, 0, 0)
	particlesize(0.5, 0.5)
	particle(p_explosion,projectiles[id].x+20,projectiles[id].y+15)
	particlecolor(255, 0, 0)
	particlesize(0.5, 0.5)
	particle(p_explosion,projectiles[id].x,projectiles[id].y+20)
	particlecolor(255, 0, 0)
	particlesize(0.7, 0.7)
	particle(p_explosion,projectiles[id].x,projectiles[id].y)
	particlesize(0.5, 0.5)
	--particlecolor(255, 0, 0)
	particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
	particlefadealpha(0.05)
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/2)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(cc.nokia.gfx_pro,projectiles[id].x,projectiles[id].y)==1 then
			if playercollision()~=0 then
				playerdamage(playercollision(),10000)
				playsound(sfx_splatter2)
			else
				if objectcollision()~=0 then
					objectdamage(objectcollision(),10000)
				end
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,25,1)
				terrainexplosion(projectiles[id].x-10,projectiles[id].y,25,1)
				terrainexplosion(projectiles[id].x+10,projectiles[id].y,25,1)
				particle(p_explosion,projectiles[id].x-10,projectiles[id].y,1)
				particlesize(0.4, 0.4)
				particle(p_explosion,projectiles[id].x+10,projectiles[id].y,1)
				particlesize(0.4, 0.4)
				playsound(cc.nokia.sfx_bounce)
				-- Particles
				for j=1,30,1 do
					particle(p_smoke,projectiles[id].x,projectiles[id].y)
					particlespeed(math.random(-10,10)*0.1,math.random(-10,10)*0.1)
					particlefadealpha(0.01)
				end
				-- Free projectile
				freeprojectile(id)
				quake(30)	
				setbgcolor(0,0,0,1.0,0.05)
				createobject(cc.nokia.tvo.id,projectiles[id].x,projectiles[id].y)
				break
			end
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			freeprojectile(id)
			break
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end

--------------------------------------------------------------------------------
-- Object: Nokia TV
--------------------------------------------------------------------------------

cc.nokia.tvo.id=addobject("cc.nokia.tvo",cc.nokia.gfx_pro)

function cc.nokia.tvo.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].sy=-3
	objects[id].timer=0
	CreepySoundPLD=0
end

function cc.nokia.tvo.draw(id,x,y)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	drawimage(cc.nokia.gfx_pro,x,y)
end

function cc.nokia.tvo.update(id,x,y)
	objects[id].sy=objects[id].sy+getgravity()
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	--D--
	if objects[id].timer>=1 then
		if objects[id].timer%2==0 then
			cc.nokia.gfx_pro=cc.nokia.gfx_pro1
			objects[id].timer=objects[id].timer-1
		else 
			cc.nokia.gfx_pro=cc.nokia.gfx_pro2
			objects[id].timer=objects[id].timer-1
		end
	end
	if objects[id].timer==0 then
		cc.nokia.gfx_pro=cc.nokia.gfx_pro3
	end
	--Creepy sound--	
	if objects[id].timer==150 then
		playsound(cc.nokia.sfx_noise)
	end
	--Creepy sound ends here--
	for i=1,msubt,1 do
		y=y+msuby
		if collision(cc.nokia.gfx_pro,x,y,1,1,1,-1,id)==1 then
			if (math.abs(objects[id].sy)>0.5) then playsound(cc.nokia.sfx_bounce)
			quake(30) 
			setbgcolor(0,0,0,0.5,0.05) end
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		if y>getwatery()+5 then
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			removeobject(id)
			return
		end
	end
	objectposition(id,x,y)
end

function cc.nokia.tvo.damage(id,damage)
	objects[id].timer=151
end
